Bug 1303764 - Review Request: xchange - Java library providing API for Bitcoin and Altcoin exchanges
Review Request: xchange - Java library providing API for Bitcoin and Altcoin ...
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: gil cattaneo
Fedora Extras Quality Assurance
:
Depends On: 1303451
Blocks:
  Show dependency treegraph
 
Reported: 2016-02-01 16:46 EST by Jonny Heggheim
Modified: 2016-02-16 02:28 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-02-16 02:28:07 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
puntogil: fedora‑review+


Attachments (Terms of Use)
xchange-3.1.0 licensecheck.txt (220.42 KB, text/plain)
2016-02-12 19:38 EST, gil cattaneo
no flags Details

  None (edit)
Description Jonny Heggheim 2016-02-01 16:46:22 EST
Spec URL: https://jonny.fedorapeople.org/xchange/xchange.spec
SRPM URL: https://jonny.fedorapeople.org/xchange/xchange-3.1.0-2.fc23.src.rpm
Fedora Account System Username: jonny
Description: XChange is a Java library providing a streamlined API for
interacting with 50+ Bitcoin and Altcoin exchanges
providing a consistent interface for trading and
accessing market data.
Comment 1 Jonny Heggheim 2016-02-01 16:51:03 EST
Some of the exchanges/modules have been disables because of missing transitive dependencies. These might be enabled later.
Comment 2 gil cattaneo 2016-02-02 14:09:34 EST
(In reply to Jonny Heggheim from comment #1)
> Some of the exchanges/modules have been disables because of missing
> transitive dependencies. These might be enabled later.

if you want use, are available @ :
https://gil.fedorapeople.org/socketio-client-java-0.4.1-1.fc22.src.rpm
https://gil.fedorapeople.org/quickfixj-1.6.1-1.fc22.src.rpm
Comment 3 gil cattaneo 2016-02-02 14:12:39 EST
... and http://pkgs.fedoraproject.org/cgit/rpms/glassfish-websocket-api.git/ aka mvn(javax.websocket:javax.websocket-client-api)
Comment 4 gil cattaneo 2016-02-02 14:17:25 EST
... and http://pkgs.fedoraproject.org/cgit/rpms/tyrus.git provides tyrus-container-grizzly-client (mvn(org.glassfish.tyrus:tyrus-container-grizzly-client))
Comment 5 Jonny Heggheim 2016-02-03 17:23:01 EST
Thanks, my plan was to use submit them for review and update this package when they are accepted
Comment 6 Jonny Heggheim 2016-02-12 16:46:05 EST
socketio-client depends on engineio-client-java that depdends on Java-WebSocket version 1.3.0, we ship version 1.3.1 and it fails to compile.

Newer versions of engineio-client-java depends on okhttp-ws (a submodule of okhttp), the upstream version of okhttp in Fedora does not have okhttp-ws.

I propose that we disable all optional modules that depends on socketio-client/engineio-client-java for now and include them when upstream uses newer version and we have upgraded to a newer version of okhttp(-ws)
Comment 7 Jonny Heggheim 2016-02-12 17:34:54 EST
> ... and http://pkgs.fedoraproject.org/cgit/rpms/glassfish-websocket-api.git/
> aka mvn(javax.websocket:javax.websocket-client-api)

> ... and http://pkgs.fedoraproject.org/cgit/rpms/tyrus.git provides
> tyrus-container-grizzly-client
> (mvn(org.glassfish.tyrus:tyrus-container-grizzly-client))

Thanks, I have updated the spec file.

Spec URL: https://jonny.fedorapeople.org/xchange/xchange.spec
SRPM URL: https://jonny.fedorapeople.org/xchange/xchange-3.1.0-3.fc24.src.rpm
Comment 8 gil cattaneo 2016-02-12 18:51:10 EST
can you take this https://bugzilla.redhat.com/show_bug.cgi?id=1282063 ?
Comment 9 gil cattaneo 2016-02-12 19:32:25 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 2246 files have
     unknown license. Detailed output of licensecheck in
     /home/gil/1303764-xchange/licensecheck.txt

 A lot of java source files are without license headers (see attachment). Please,
 ask to upstream to confirm the licensing of code and/or content/s adding license headers
 https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/LicensingGuidelines#License_Clarification

[x]: License file installed when any subpackage combination is installed.
[-]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in xchange-
     javadoc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[?]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: xchange-3.1.0-3.fc24.noarch.rpm
          xchange-javadoc-3.1.0-3.fc24.noarch.rpm
          xchange-3.1.0-3.fc24.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: File o directory non esistente
2 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
xchange-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils

xchange (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(com.github.mmazi:rescu)
    mvn(com.pusher:pusher-java-client)
    mvn(commons-io:commons-io)
    mvn(io.netty:netty-all)
    mvn(javax.json:javax.json-api)
    mvn(javax.websocket:javax.websocket-client-api)
    mvn(net.iharder:base64)
    mvn(org.apache.commons:commons-lang3)
    mvn(org.bouncycastle:bcprov-jdk15on)
    mvn(org.java-websocket:Java-WebSocket)
    mvn(org.slf4j:slf4j-api)



Provides
--------
xchange-javadoc:
    xchange-javadoc

xchange:
    mvn(com.xeiam.xchange:xchange-anx)
    mvn(com.xeiam.xchange:xchange-anx:pom:)
    mvn(com.xeiam.xchange:xchange-bitbay)
    mvn(com.xeiam.xchange:xchange-bitbay:pom:)
    mvn(com.xeiam.xchange:xchange-bitcoinaverage)
    mvn(com.xeiam.xchange:xchange-bitcoinaverage:pom:)
    mvn(com.xeiam.xchange:xchange-bitcoincharts)
    mvn(com.xeiam.xchange:xchange-bitcoincharts:pom:)
    mvn(com.xeiam.xchange:xchange-bitcoinde)
    mvn(com.xeiam.xchange:xchange-bitcoinde:pom:)
    mvn(com.xeiam.xchange:xchange-bitcoinium)
    mvn(com.xeiam.xchange:xchange-bitcoinium:pom:)
    mvn(com.xeiam.xchange:xchange-bitcurex)
    mvn(com.xeiam.xchange:xchange-bitcurex:pom:)
    mvn(com.xeiam.xchange:xchange-bitfinex)
    mvn(com.xeiam.xchange:xchange-bitfinex:pom:)
    mvn(com.xeiam.xchange:xchange-bitkonan)
    mvn(com.xeiam.xchange:xchange-bitkonan:pom:)
    mvn(com.xeiam.xchange:xchange-bitmarket)
    mvn(com.xeiam.xchange:xchange-bitmarket:pom:)
    mvn(com.xeiam.xchange:xchange-bitso)
    mvn(com.xeiam.xchange:xchange-bitso:pom:)
    mvn(com.xeiam.xchange:xchange-bitstamp)
    mvn(com.xeiam.xchange:xchange-bitstamp:pom:)
    mvn(com.xeiam.xchange:xchange-bittrex)
    mvn(com.xeiam.xchange:xchange-bittrex:pom:)
    mvn(com.xeiam.xchange:xchange-bleutrade)
    mvn(com.xeiam.xchange:xchange-bleutrade:pom:)
    mvn(com.xeiam.xchange:xchange-blockchain)
    mvn(com.xeiam.xchange:xchange-blockchain:pom:)
    mvn(com.xeiam.xchange:xchange-btc38)
    mvn(com.xeiam.xchange:xchange-btc38:pom:)
    mvn(com.xeiam.xchange:xchange-btccentral)
    mvn(com.xeiam.xchange:xchange-btccentral:pom:)
    mvn(com.xeiam.xchange:xchange-btce)
    mvn(com.xeiam.xchange:xchange-btce:pom:)
    mvn(com.xeiam.xchange:xchange-btctrade)
    mvn(com.xeiam.xchange:xchange-btctrade:pom:)
    mvn(com.xeiam.xchange:xchange-bter)
    mvn(com.xeiam.xchange:xchange-bter:pom:)
    mvn(com.xeiam.xchange:xchange-campbx)
    mvn(com.xeiam.xchange:xchange-campbx:pom:)
    mvn(com.xeiam.xchange:xchange-cavirtex)
    mvn(com.xeiam.xchange:xchange-cavirtex:pom:)
    mvn(com.xeiam.xchange:xchange-cexio)
    mvn(com.xeiam.xchange:xchange-cexio:pom:)
    mvn(com.xeiam.xchange:xchange-clevercoin)
    mvn(com.xeiam.xchange:xchange-clevercoin:pom:)
    mvn(com.xeiam.xchange:xchange-coinbase)
    mvn(com.xeiam.xchange:xchange-coinbase:pom:)
    mvn(com.xeiam.xchange:xchange-coinbaseex)
    mvn(com.xeiam.xchange:xchange-coinbaseex:pom:)
    mvn(com.xeiam.xchange:xchange-coinfloor)
    mvn(com.xeiam.xchange:xchange-coinfloor:pom:)
    mvn(com.xeiam.xchange:xchange-coinmate)
    mvn(com.xeiam.xchange:xchange-coinmate:pom:)
    mvn(com.xeiam.xchange:xchange-cointrader)
    mvn(com.xeiam.xchange:xchange-cointrader:pom:)
    mvn(com.xeiam.xchange:xchange-core)
    mvn(com.xeiam.xchange:xchange-core:pom:)
    mvn(com.xeiam.xchange:xchange-cryptonit)
    mvn(com.xeiam.xchange:xchange-cryptonit:pom:)
    mvn(com.xeiam.xchange:xchange-cryptsy)
    mvn(com.xeiam.xchange:xchange-cryptsy:pom:)
    mvn(com.xeiam.xchange:xchange-empoex)
    mvn(com.xeiam.xchange:xchange-empoex:pom:)
    mvn(com.xeiam.xchange:xchange-hitbtc)
    mvn(com.xeiam.xchange:xchange-hitbtc:pom:)
    mvn(com.xeiam.xchange:xchange-independentreserve)
    mvn(com.xeiam.xchange:xchange-independentreserve:pom:)
    mvn(com.xeiam.xchange:xchange-itbit)
    mvn(com.xeiam.xchange:xchange-itbit:pom:)
    mvn(com.xeiam.xchange:xchange-jubi)
    mvn(com.xeiam.xchange:xchange-jubi:pom:)
    mvn(com.xeiam.xchange:xchange-kraken)
    mvn(com.xeiam.xchange:xchange-kraken:pom:)
    mvn(com.xeiam.xchange:xchange-lakebtc)
    mvn(com.xeiam.xchange:xchange-lakebtc:pom:)
    mvn(com.xeiam.xchange:xchange-loyalbit)
    mvn(com.xeiam.xchange:xchange-loyalbit:pom:)
    mvn(com.xeiam.xchange:xchange-mercadobitcoin)
    mvn(com.xeiam.xchange:xchange-mercadobitcoin:pom:)
    mvn(com.xeiam.xchange:xchange-mexbt)
    mvn(com.xeiam.xchange:xchange-mexbt:pom:)
    mvn(com.xeiam.xchange:xchange-okcoin)
    mvn(com.xeiam.xchange:xchange-okcoin:pom:)
    mvn(com.xeiam.xchange:xchange-openexchangerates)
    mvn(com.xeiam.xchange:xchange-openexchangerates:pom:)
    mvn(com.xeiam.xchange:xchange-parent:pom:)
    mvn(com.xeiam.xchange:xchange-poloniex)
    mvn(com.xeiam.xchange:xchange-poloniex:pom:)
    mvn(com.xeiam.xchange:xchange-quoine)
    mvn(com.xeiam.xchange:xchange-quoine:pom:)
    mvn(com.xeiam.xchange:xchange-ripple)
    mvn(com.xeiam.xchange:xchange-ripple:pom:)
    mvn(com.xeiam.xchange:xchange-taurus)
    mvn(com.xeiam.xchange:xchange-taurus:pom:)
    mvn(com.xeiam.xchange:xchange-therock)
    mvn(com.xeiam.xchange:xchange-therock:pom:)
    mvn(com.xeiam.xchange:xchange-vircurex)
    mvn(com.xeiam.xchange:xchange-vircurex:pom:)
    mvn(com.xeiam.xchange:xchange-yacuna)
    mvn(com.xeiam.xchange:xchange-yacuna:pom:)
    xchange



Source checksums
----------------
https://github.com/timmolter/XChange/archive/xchange-3.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : 993786a117b69b73361a6f6bc07cbcf2371e1991098638f34b2c597310e2d493
  CHECKSUM(SHA256) upstream package : 993786a117b69b73361a6f6bc07cbcf2371e1991098638f34b2c597310e2d493


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1303764 --plugins Java -m fedora-rawhide-i386 -L /home/gil/deps
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Built with local dependencies:
    /home/gil/deps/pusher-java-client-1.0.1-1.fc24.noarch.rpm
Comment 10 gil cattaneo 2016-02-12 19:38 EST
Created attachment 1123699 [details]
xchange-3.1.0 licensecheck.txt
Comment 11 gil cattaneo 2016-02-12 19:39:24 EST
Issues:

[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 2246 files have
     unknown license. Detailed output of licensecheck in
     /home/gil/1303764-xchange/licensecheck.txt

 A lot of java source files are without license headers (see attachment). Please,
 ask to upstream to confirm the licensing of code and/or content/s adding license headers
 https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/LicensingGuidelines#License_Clarification
Comment 12 Jonny Heggheim 2016-02-13 17:12:09 EST
> Please, ask to upstream to confirm the licensing of code and/or content/s
> adding license headers

https://github.com/timmolter/XChange/issues/1185
Comment 13 Jonny Heggheim 2016-02-13 17:14:01 EST
> can you take this https://bugzilla.redhat.com/show_bug.cgi?id=1282063 ?

Yes, I will spend my next available "Fedora package time session" looking at it.
Comment 14 gil cattaneo 2016-02-13 17:46:26 EST
(In reply to Jonny Heggheim from comment #13)
> > can you take this https://bugzilla.redhat.com/show_bug.cgi?id=1282063 ?
> 
> Yes, I will spend my next available "Fedora package time session" looking at
> it.

Thanks
Comment 15 gil cattaneo 2016-02-13 17:48:17 EST
(In reply to Jonny Heggheim from comment #12)
> > Please, ask to upstream to confirm the licensing of code and/or content/s
> > adding license headers
> 
> https://github.com/timmolter/XChange/issues/1185

Approved, but https://github.com/timmolter/XChange/issues/1185 should be fixed
Comment 16 Gwyn Ciesla 2016-02-15 10:13:13 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/xchange

Note You need to log in before you can comment on or make changes to this bug.